<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>THÔNG TIN LIÊN HỆ CHI TIẾT</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct"
        crossorigin="anonymous"></script>
</head>

<body onload="onPageLoading()">
    <div class="container jumbotron">
        <div class="header text-center">
            <h2 style=" margin-bottom: 40px;">THÔNG TIN LIÊN HỆ CHI TIẾT</h2>
        </div>
        <div class="row form-group" style="margin-bottom:40px">
            <div class="col-sm-4 text-right">
                <label for="" style="font-weight: 500;">Name<span style="color:red;font-weight: 500;">
                        (*)</span></label>
            </div>
            <div class="col-sm-8">
                <input id="input-name" class="form-control" type="text" placeholder="..." style="width: 450px;">
            </div>
        </div>
        <div class="row form-group" style="margin-bottom:40px">
            <div class="col-sm-4 text-right">
                <label for="" style="font-weight: 500;">Email<span style="color:red;font-weight: 500;">
                        (*)</span></label>
            </div>
            <div class="col-sm-8">
                <input id="input-email" class="form-control" type="text" placeholder="..." style="width: 450px;">
            </div>
        </div>
        <div class="row form-group" style="margin-bottom:40px">
            <div class="col-sm-4 text-right">
                <label for="" style="font-weight: 500;">Message<span style="color:red;font-weight: 500;">
                        (*)</span></label>
            </div>
            <div class="col-sm-8">
                <textarea id="textarea-message" class="form-control" name="message" id="textarea-message" cols="30"
                    rows="4" style="width: 450px;line-height: 15px; padding-top: 40px;" placeholder="..."></textarea>
            </div>
        </div>
        <div class="row form-group" style="margin-bottom:40px">
            <div class="col-sm-4 text-right">
                <label for="" style="font-weight: 500;">Ngày liên hệ<span style="color:red;font-weight: 500;">
                        (*)</span></label>
            </div>
            <div class="col-sm-8">
                <input id="input-contact-date" class="form-control" type="text" placeholder="..."
                    style="width: 450px; ">
            </div>
        </div>
        <div class="row form-group" style="margin-bottom:40px">
            <div class="col-sm-9 text-right">
                <button onclick="onBtnSaveDataClick ()" class="btn btn-success" style="background-color: #548235;">Save
                    data</button>
            </div>

        </div>
    </div>
    <script>
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        var gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm tải trang
        function onPageLoading() {
            var vUrlString = window.location.href;
            var vUrl = new URL(vUrlString);
            var vContactId = vUrl.searchParams.get("id");

            // Gọi hàm kiểm tra có id hay không
            var vIdHopLe = kiemTraId(vContactId);
            if (vIdHopLe) {
                // Gọi hàm call Api lấy chi tiết contact by ID
                callApiGetContactById(vContactId);
            }
        }

        // Hàm nhấn nút lưu dữ liệu
        function onBtnSaveDataClick() {
            var vUrlString = window.location.href;
            var vUrl = new URL(vUrlString);
            var vContactId = vUrl.searchParams.get("id");

            var vUpdateContactObj = {
                name: "",
                email: "",
                message: "",
                createDate: ""
            };
            // Thu thập dữ liệu
            thuThapDuLieuUpdate(vUpdateContactObj);
            // Kiểm tra dữ liệu
            var vUpdateContactObjHopLe = kiemTraDuLieuUpdate(vUpdateContactObj);
            if (vUpdateContactObjHopLe) {
                // Gọi Api cập nhật dữ liệu
                callApiUpdateDataByClick(vUpdateContactObj, vContactId)
            }
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm kiểm tra có id hay không
        function kiemTraId(paramContactId) {
            if (paramContactId === "" || paramContactId === null) {
                alert("Chưa có ID");
                window.location.href = "listContact.html";
                return false
            }
            return true;
        }
        // Hàm gọi Api lấy contact chi tiết bằng id
        function callApiGetContactById(paramContactId) {
            const vAPI_URL = gBASE_URL + "/contacts/";
            var vXmlHttp = new XMLHttpRequest();
            vXmlHttp.open("GET", vAPI_URL + paramContactId, true);
            vXmlHttp.send();
            vXmlHttp.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttp.responseText);
                    var vContactObj = JSON.parse(vXmlHttp.responseText);
                    console.log(vContactObj)
                    // Gọi hàm hiển thị dữ liệu lên form
                    hienThiDuLieuLenForm(vContactObj);
                }
            }
        }

        //Hàm gọi api cập nhật dữ liệu 
        function callApiUpdateDataByClick(paramContactObj, paramId) {
            const vAPI_URL = gBASE_URL + "/contacts/";

            var vXmlHttp = new XMLHttpRequest();
            vXmlHttp.open("PUT", vAPI_URL + paramId, true);
            vXmlHttp.setRequestHeader("Content-Type", "application/json");
            vXmlHttp.send(JSON.stringify(paramContactObj));

            vXmlHttp.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttp.responseText);
                    alert("Sửa thông tin liên hệ thành công")
                    window.location.href = "listContact.html"
                }
            }
        }
        // Gọi hàm hiển thị dữ liệu lên form
        function hienThiDuLieuLenForm(paramContactObj) {

            var vInputName = document.getElementById("input-name");
            var vInputEmail = document.getElementById("input-email");
            var vTextareaMessage = document.getElementById("textarea-message");
            var vInputContactDate = document.getElementById("input-contact-date");

            vInputName.value = paramContactObj.name;
            vInputEmail.value = paramContactObj.email;
            vTextareaMessage.value = paramContactObj.message;
            vInputContactDate.value = paramContactObj.createDate;
        }

        // Hàm thu thập dữ liệu update 
        function thuThapDuLieuUpdate(paramUpdateContactObj) {
            var vInputName = document.getElementById("input-name");
            var vInputEmail = document.getElementById("input-email");
            var vTextareaMessage = document.getElementById("textarea-message");
            var vInputContactDate = document.getElementById("input-contact-date");

            paramUpdateContactObj.name = vInputName.value.trim();
            paramUpdateContactObj.email = vInputEmail.value.trim();
            paramUpdateContactObj.message = vTextareaMessage.value.trim();
            paramUpdateContactObj.createDate = vInputContactDate.value.trim();
        }


        // Hàm kiểm tra dữ liệu update
        function kiemTraDuLieuUpdate(paramUpdateContactObj) {
            // Các thông tin đều phải nhập (không được để trống)
            if (paramUpdateContactObj.name === "") {
                alert("Vui lòng nhập name");
                return false;
            }
            if (paramUpdateContactObj.email === "") {
                alert("Vui lòng nhập email");
                return false;
            }
            if (paramUpdateContactObj.message === "") {
                alert("Vui lòng nhập message");
                return false;
            }
            if (paramUpdateContactObj.createDate === "") {
                alert("Vui lòng nhập ngày cập nhật");
                return false;
            }

            // Email phải đúng định dạng
            var vEmailRegex = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
            if (!paramUpdateContactObj.email.match(vEmailRegex)) {
                alert('Email không đúng định dạng');
                return false;
            }

            // Message phải có độ dài trên 20 ký tự
            if (paramUpdateContactObj.message.length <= 20) {
                alert("Message phải có độ dài trên 20 ký tự");
                return false;
            }

            // Kiểm tra định dạng ngày
            var dateformat = /^(0?[1-9]|[12][0-9]|3[01])[\/\-](0?[1-9]|1[012])[\/\-]\d{4}$/;
            if (!paramUpdateContactObj.createDate.match(dateformat)) {
                alert("Ngày không đúng định dạng");
                return false;
            }
            return true;
        }

    </script>
</body>

</html>